;**************************************************************
;*   FILE HANDLING AND MEMORY ALLOCATION MODULE		      *
;*       Copyright(c) Bognr Andrs 2006		      *
;**************************************************************
[BITS 16]		;Set code generation to 16 bit mode
[SEGMENT .text]		;Main code segment

HIBS! Valsznleg a helyi vltozkra val hvatkozsok esetn ki
kell tenni a cs: prefixet!

GLOBAL _allocate      	;allocate memory
GLOBAL _mfree          	;free memory
GLOBAL _openr          	;Open a file to read
GLOBAL _openw          	;Open a file to write
GLOBAL _closefile       ;Close an opened file
GLOBAL _readb           ;Read from a file a block
GLOBAL _writeb          ;write to the file a block
GLOBAL _read	      	;Read from a file a character
GLOBAL _write           ;write to the file a character
GLOBAL _endf		;shows if End Of file reached
GLOBAL _ferr            ;Returns 1 if file error occured

cpy db 'File and Memory handling Copyright(c) Bognr Andrs 2006',0
mem dw 0		;allocated memory pointer [seg]
tbuf db 0		;Temporary buffer (char: read, write)
fileerr db 0            ;File error flag
eof db 0		;End of file flag

_allocate:              ;Allocate memory
push bp                 ;Returns NULL if error
push bx
mov bp,sp
mov ah,48h
mov bx,[bp+8]        	;size of block in paragraphs
int 21h
jc mhiba1
mov [cs:mem],ax           	;save pointer
mov dx,ax
xor ax,ax
pop bx
pop bp
retf
mhiba1: xor ax,ax
xor dx,dx
pop bx
pop bp
retf

_mfree:          	;Free memory
push bp
push es
mov bp,sp
mov ax,[bp+10]       	;Blokk cme
mov es,ax
mov ah,49h              ;Returns 1 if error
int 21h
jc mhiba2
xor ax,ax
pop es
pop bp
retf
mhiba2: mov ax,1
pop es
pop bp
retf

_openr:         	;open a file to read
push ds
push dx
push bp
mov bp,sp
mov ax,[bp+12]        	;filename seg.
mov ds,ax
mov dx,[bp+10]        	;filename offs.
mov ax,3D00h
int 21h                 ;returns: AX=fileno
jc ferr1
mov dl,0
mov [cs:fileerr],dl
jmp op1
ferr1:
mov dl,1
mov [cs:fileerr],dl
op1:
pop bp
pop dx
pop ds
retf

_openw:            	;open a file to write
push ds
push dx
push cx
push bp
mov bp,sp
mov ax,[bp+14]        	;filename seg.
mov ds,ax
mov dx,[bp+12]          ;filename offs.
mov ax,3C00h
mov cx,0
int 21h                	;returns: AX=fileno
jc ferr2
mov dl,0
mov [cs:fileerr],dl
jmp op2
ferr2:
mov dl,1
mov [cs:fileerr],dl
op2:
pop bp
pop cx
pop dx
pop ds
retf

_closefile:      	;close an opened file
push bx                 ;AX=1->error
push bp
mov bp,sp
mov ax,3E00h
mov bx,[bp+8]       	;Fileno
int 21h
jc ferr3
mov bl,0
mov [cs:fileerr],bl
mov ax,0
pop bp
pop bx
retf
ferr3:
mov bl,1
mov [fileerr],bl
mov ax,1
pop bp
pop bx
retf

_readb:            	;read a block from a file
push bx
push ds
push dx
push cx
push bp
mov bp,sp
mov bx,[bp+14]       	;Fileno
mov ax,[bp+20]          ;buffer seg.
mov ds,ax
mov dx,[bp+18]          ;buffer offs.
mov cx,[bp+16]          ;size
mov ax,3F00h
int 21h
jc ferr4
mov bx,0
mov [fileerr],bl
cmp ax,[bp+16]		;is EOF?
jz noteof1
mov bx,1
mov [eof],bl
jmp rd1
noteof1:		;not EOF
xor bx,bx
mov [eof],bl
jmp rd1
ferr4:   		;error
mov bx,1
mov [fileerr],bl
xor bx,bx
mov [eof],bl
xor ax,ax		;return 0
rd1:
pop bp
pop cx
pop dx
pop ds
pop bx
retf

_writeb:          	;write a block to a file
push bx
push ds
push dx
push cx
push bp
mov bp,sp
mov bx,[bp+14]     	;Fileno
mov ax,[bp+20]        	;buffer seg.
mov ds,ax
mov dx,[bp+18]        	;buffer offs.
mov cx,[bp+16]          ;size
mov ax,4000h
int 21h
jc ferr5
mov bx,0
mov [fileerr],bl
cmp ax,[bp+16]		;Is all byte written in?
jz rd2
xor ax,ax
jmp rd2
ferr5:
mov bx,1
mov [fileerr],bl
xor ax,ax		;return 0
rd2:
pop bp
pop cx
pop dx
pop ds
pop bx
retf

_read:             	;read a char from a file
push bx
push ds
push dx
push cx
push bp
mov bp,sp
mov bx,[bp+14]      	;Fileno
push cs
pop ds
mov dx,tbuf
mov cx,1
mov ax,3F00h
int 21h
jc ferr44
mov bx,0
mov [fileerr],bl
cmp ax,1		;is EOF?
jz noteof2
mov ax,1
mov [eof],al
xor ax,ax
not ax
jmp rd11
noteof2:		;not EOF
xor ax,ax
mov [eof],al
mov al,[tbuf]
jmp rd11
ferr44: 		;file error
mov bx,1
mov [fileerr],bl
xor bx,bx
mov [eof],bl
xor ax,ax
not ax
rd11:
pop bp
pop cx
pop dx
pop ds
pop bx
retf

_write:         	;write a char to a file
push bx
push ds
push dx
push cx
push bp
mov bp,sp
mov bx,[bp+16]          ;Fileno
mov ax,[bp+14]	      	;data
mov [tbuf],al
push cs
pop ds
mov dx,tbuf
mov cx,1
mov ax,4000h
int 21h
jc ferr55
mov bx,0
mov [fileerr],bl
cmp ax,1		;Is the given byte written in?
jz written5
xor ax,ax
not ax
jmp rd22
written5:
xor ax,ax
jmp rd22
ferr55:
mov bx,1
mov [fileerr],bl
xor ax,ax
not ax
rd22:
pop bp
pop cx
pop dx
pop ds
pop bx
retf

_ferr:                	;Returns 1 if file error occured
xor ax,ax
mov al,[fileerr]
retf

_endf:           	;Returns 1 if end of file reached
xor ax,ax
mov al,[eof]
retf