;Hangkrtya meghajtsa DMA-val, teljes file lejtszsa
;sound card: PORT220 , DMA1 , IRQ5

;Teljes file-ot jtszik le
%include "bnd_mac.h"
sz1 db 'Sound Card driver with DMA',10,13,0
sz2 db 'Interrupt was detected',10,13,0
sz3 db 'Input file to play: ',0
err1 db 'Memory allocation error',10,13,0
err2 db 'Error reading the file',10,13,0
err3 db 'Sound Card is not exist',10,13,0
poi dw 0;pointer to the allocated mem.
file db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
     db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
     db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
fileno dw 0
flag db 0;interrupt flag
lastblock db 0
freq dw 20000; sample frequency [Hz]
mszak dd 0;int 0DH rgi rtke
mask db 0; interrupt mask

inte:;IRQ5 interrupt routine
push ax
push ds
push dx
mov ax,cs
mov ds,ax
cli
mov al,20h
out 20h,al
sti
mov dx,22Eh;read the state
in al,dx
mov al,1
mov [flag],al
;ring
pop dx
pop ds
pop ax
iret

initsound:;reset and control
mov dx,226h
mov al,1
out dx,al
delay 10,10
mov al,0
out dx,al
delay 10,10
;mov dx,22Eh
;in al,dx
;test al,80H
;jz serr
;mov dx,22Ah
;in al,dx
;cmp al,0AAh
;jnz serr
ret
serr:
putbs 0,err3;not exist
end

writedsp:; al=data
push ax
varas1:
mov dx,22Ch
in al,dx
test al,80H
jnz varas1
pop ax
out dx,al
ret

readdsp:;al=data
mov dx,22Eh
in al,dx
test al,80h
jz readdsp
mov dx,22Ah
in al,dx
ret

speakeron:;bekapcsols
mov al,0D1h
call writedsp
ret

speakeroff:
mov al,0D3h
call writedsp
ret

dmastop:
mov al,0D0h
call writedsp
ret

dmacontinue:
mov al,0D4h
call writedsp
ret

bill:;keyboard control routine
ret

read_high:;load high 64kB block
mov ax,[poi]
add ax,4096
jmp at003
read_low:;load low 64kB block
mov ax,[poi]
at003:
mov bx,[fileno]
mov ds,ax
mov dx,0
mov cx,32768
mov ax,3F00h
int 21h
jc ferror
cmp ax,32768
jnz utolso
mov ax,3F00h
mov dx,32768
int 21h
jc ferror
cmp ax,32768
jnz utolso
mov bx,cs
mov ds,bx
ret
utolso:
add dx,ax
mov al,80h
mov bx,0FFFFh
zero:
mov [bx],al
dec bx
cmp bx,dx
jnz zero
mov bx,cs
mov ds,bx
mov bl,1
mov [lastblock],bl
ret
ferror:
pop ax
puteol
putbs 0,err2
jmp vege

start:;****************  START*******************************************
;SET DISPLAY, RESET CARD
clrscr
putbs 0,sz1
puteol
putbs 0,sz3
getbs 80,file
puteol
call initsound
;ALLOCATE MEMORY
mov ax,4A00h; memory rename : CODE SEGMENT=64kB
mov bx,4096
int 21h
push cs
pop ss
mov ax,0fffdh
mov sp,ax
jc hiba
mov ax,4800h; asking for 192kB memory
mov bx,12288
int 21h
jc hiba;ax=pointer
add ax,4096; computing the DMA puffer address
mov dx,0;    DMAseg=((allocated_seg)div 4096)*4096
mov bx,4096
div bx
mul bx
push cs
pop ds
mov [poi],ax;save the pointer
jmp at001
hiba:
putbs 0,err1;memory error
jmp vege

at001:
;READ THE FILE
mov ax,3d00h;open a file
mov dx,file
int 21h
jc ferror5
jmp at009
ferror5: jmp ferror
at009:
mov [fileno],ax
mov bx,ax
mov ah,3fh
mov dx,puffer1
mov cx,100
int 21h;read the .wav file header
jc ferror1
jmp at006
ferror1: jmp ferror
at006:
call read_low;initial
mov al,[lastblock]
cmp al,1
jz at004
call read_high
at004:
;INTERRUPT SETTINGS
cli
xor ax,ax;save and set interrupt vector
mov ds,ax
mov ax,[0Dh*4]
mov [es:mszak],ax
mov ax,[0Dh*4+2]
mov [es:mszak+2],ax
mov ax,inte
mov [0Dh*4],ax
mov [0Dh*4+2],cs
push cs
pop ds
;set interrupt mask register
in al,21h
mov [mask],al;save mask
and al,11011111b
out 21h,al;set mask , IRQ5 = Enabled
sti
;DMA SETTING
call speakeron
mov al,01h;[dmach]
add al,04h
out 0Ah,al;mask reg.
mov al,0
out 0Ch,al;Clear the internal DMA flip-flop
mov al,01h;[dmach]
add al,48h
out 0Bh,al; Mode reg.
mov ax,[poi];cmszmts
mov bx,16
mul bx;dx:ax= lin cm
out 02h,al; lin cm als 8 bit
mov al,ah
out 02h,al; lin cm kv 8  bit
mov al,dl
out 83h,al;page reg.
mov al,0FFh
out 03h,al;size low
mov al,0FFh
out 03h,al;size high
mov al,01h
out 0Ah,al;mask reg = enable DMA
;DSP SETTING
mov al,40h; set the sample rate
call writedsp
mov dx,15
mov ax,16960
mov bx,[freq]
div bx
mov dx,256
sub dx,ax
mov al,dl
call writedsp; 256 - 1 000 000 Div Freq
mov al,14h;8 bit playing with DMA
call writedsp
mov al,0ffh; size low
call writedsp
mov al,0ffh;size high
call writedsp
mov al,[lastblock];last block played?
cmp al,1
jz exit1;exit from playing blocks
jmp at007
exit1: jmp exit
at007:

;********************MAIN PLAYING CICLE***********************
playing:
mov ax,cs
mov ds,ax
waiting1:;waiting for interrupt and kbhit
mov al,[flag]
cmp al,1
jz nextblock1
mov ah,0Bh
int 21h
cmp al,0FFh
jnz waiting1
call bill; keyboard routine
jmp waiting1
nextblock1:
mov al,0
mov [flag],al
;PLAY BLOCK2
;   dma
mov al,01h;[dmach]
add al,04h
out 0Ah,al;mask register -> disable ch1
mov al,0
out 0Ch,al;Clear the internal DMA flip-flop
mov ax,[poi];cmszmts
add ax,4096
mov bx,16
mul bx;dx:ax= lin cm
out 02h,al; lin cm als 8 bit
mov al,ah
out 02h,al; lin cm kv 8  bit
mov al,dl
out 83h,al;page reg.
mov al,01h
out 0Ah,al;mask reg = enable DMA
;    dsp
mov al,14h;8 bit playing with DMA
call writedsp
mov al,0ffh; size low
call writedsp
mov al,0ffh;size high
call writedsp
;LAST BLOCK?
mov al,[lastblock]
cmp al,1
jz exit
call read_low;load block1

mov ax,cs
mov ds,ax
waiting2:;waiting for interrupt and kbhit
mov al,[flag]
cmp al,1
jz nextblock2
mov ah,0Bh
int 21h
cmp al,0FFh
jnz waiting2
call bill; keyboard routine
jmp waiting2
nextblock2:
mov al,0
mov [flag],al
;PLAY BLOCK1
;   dma
mov al,01h;[dmach]
add al,04h
out 0Ah,al;mask register -> disable ch1
mov al,0
out 0Ch,al;Clear the internal DMA flip-flop
mov ax,[poi];cmszmts
mov bx,16
mul bx;dx:ax= lin cm
out 02h,al; lin cm als 8 bit
mov al,ah
out 02h,al; lin cm kv 8  bit
mov al,dl
out 83h,al;page reg.
mov al,01h
out 0Ah,al;mask reg = enable DMA
;    dsp
mov al,14h;8 bit playing with DMA
call writedsp
mov al,0ffh; size low
call writedsp
mov al,0ffh;size high
call writedsp
;LAST BLOCK?
mov al,[lastblock]
cmp al,1
jz exit
call read_high;load block2
jmp playing

exit:; end of the playing
;CLOSE THE FILE
mov ah,3Eh
mov bx,[fileno]
int 21h
jc ferror2
jmp at008
ferror2: jmp ferror
at008:
;WAITING
mov ax,cs
mov ds,ax
waiting3:;waiting for interrupt and kbhit
mov al,[flag]
cmp al,1
jz nextblock3
mov ah,0Bh
int 21h
cmp al,0FFh
jnz waiting3
call bill; keyboard routine
jmp waiting3
nextblock3:
mov al,0
mov [flag],al

;RESTORE INTERRUPT VECTOR
xor ax,ax
mov ds,ax
push cs
pop es
cli
mov ax,[es:mszak]
mov [0Dh*4],ax
mov ax,[es:mszak+2]
mov [0Dh*4+2],ax
mov ax,cs
mov ds,ax
;RESTORE INTERRUPT MASK
mov al,[mask]
out 21h,al
sti
vege:
;FREE MEMORY
mov ax,cs
mov ds,ax
mov ax,4900h
mov bx,[poi]
mov es,bx
int 21h
end

puffer1: