;Hangkrtya meghajtsa DMA-val
;sound card: DMA1 , IRQ5

;Digitalizls egszen gombnyomsig
%include "bnd_mac.h"
%include "sound.h"
sz1 db 'Sound Card driver with DMA',10,13,0
sz2 db 'Interrupt was detected',10,13,0
err1 db 'Memory allocation error',10,13,0
err2 db 'Error writing the file',10,13,0
err3 db 'Sound Card is not exist',10,13,0
poi dw 0;pointer to the allocated mem.
file db 'c:\temp\sample.wav',0
fileno dw 0
freq dw 20000; sample frequency [Hz]
mask db 0; interrupt mask
mszak dd 0;int 0DH rgi rtke
phase db 1; DMA buffer phase pointer (lower or higher 64KB is written)

bill:;--------------------Key handler routine------------------------------
mov ax,0
int 16h
cmp al,32;SPACE -> stop recording
jz stoprecord
ret
stoprecord:
pop ax;empty the stack
pop ax
call dmastop
mov al,01h;disable DMA CH1
add al,04h
out 0Ah,al
mov ax,cs;save last block
mov ds,ax
mov al,[phase]
cmp al,1
jz first_b
call save2
jmp at201
first_b:
call save1
at201:;close file
mov bx,[fileno]
mov ah,3Eh
int 21h
jc ferrorw5
jmp vege;deinit
ferrorw5: jmp ferrorw

waiting:;waiting for interrupt and kbhit
mov al,[flag]
cmp al,1
jz nextblock
mov ah,0Bh
int 21h
cmp al,0FFh
jnz waiting
call bill; keyboard routine
jmp waiting
nextblock:
mov al,0
mov [flag],al
ret

save1:;save the first block
mov bx,[fileno]
mov ax,[poi]
jmp at102
save2:;save the second block
mov bx,[fileno]
mov ax,[poi]
add ax,4096
at102:
mov ds,ax
mov dx,0
mov cx,32768
mov ah,40h
int 21h
jc ferrorw2
mov dx,32768
mov cx,32768
mov ah,40h
int 21h
jc ferrorw2
push cs
pop ds
ret
ferrorw2:
putbs 0,err2
end

start:;****************  START*******************************************
call initsound
mov dx,22Eh;read the state
in al,dx
call setmixer
clrscr
putbs 0,sz1
mov ax,4A00h; memory rename : CODE SEGMENT=64kB
mov bx,4096
int 21h
push cs
pop ss
mov ax,0fffdh
mov sp,ax
jc hiba
mov ax,4800h; asking for 192kB memory
mov bx,12288
int 21h
jc hiba;ax=pointer
add ax,4096; computing the DMA puffer address
mov dx,0;    DMAseg=((allocated_seg)div 4096)*4096
mov bx,4096
div bx
mul bx
push cs
pop ds
mov [poi],ax;save the pointer
jmp at001
hiba:
putbs 0,err1
end

ferrorw:
putbs 0,err2
end

at001:
mov ah,3Ch            ;open a file to write
mov dx,file
mov cx,0
int 21h
jc ferrorw
mov [fileno],ax
cld                   ;zero low block
push es
mov ax,[poi]
mov es,ax
mov ax,8080h
mov cx,32768
mov di,0
rep stosw
mov ax,[poi]         ;zero high block
add ax,4096
mov es,ax
mov ax,8080h
mov cx,32768
mov di,0
rep stosw
pop es

;*****************Init for playing**************************************
;INTERRUPT SETTINGS
cli
xor ax,ax;save and set interrupt vectors
mov ds,ax
mov ax,[0Dh*4];IRQ5
mov [es:mszak],ax
mov ax,[0Dh*4+2]
mov [es:mszak+2],ax
mov ax,inte
mov [0Dh*4],ax
mov [0Dh*4+2],cs
push cs
pop ds
;set interrupt mask register
in al,21h
mov [mask],al;save mask
and al,11011111b
out 21h,al;set mask
sti
;DMA SETTING
mov al,01h;[dmach]
add al,04h
out 0Ah,al;mask reg.
mov al,0
out 0Ch,al;Clear the internal DMA flip-flop
mov al,01h;[dmach]
add al,44h
out 0Bh,al; Mode reg.
mov ax,[poi];cmszmts
mov bx,16
mul bx;dx:ax= lin cm
out 02h,al; lin cm als 8 bit
mov al,ah
out 02h,al; lin cm kv 8  bit
mov al,dl
out 83h,al;page reg.
mov al,0FFh;size
out 03h,al;size low
mov al,0FFh
out 03h,al;size high
mov al,01h
out 0Ah,al;mask reg = enable DMA
;DSP SETTING
mov al,40h; set the sample rate
call writedsp
mov dx,15
mov ax,16960
mov bx,[freq]
div bx
mov dx,256
sub dx,ax
mov al,dl
call writedsp; 256 - 1 000 000 Div Freq
mov al,24h;8 bit digitalizing with DMA
call writedsp
mov al,0ffh; size low
call writedsp
mov al,0ffh;size high
call writedsp
mov ax,cs
mov ds,ax
mov al,1;first phase (lower 64kB)
mov [phase],al

;RECORDING MAIN CICLE
record:
call waiting
call save1;save the first block
cld ;zero
push es
mov ax,[poi]
mov es,ax
mov ax,8080h
mov cx,32768
mov di,0
rep stosw
pop es
;dma+dsp setting to 2.block
;dma:
mov al,01h;[dmach]
add al,04h
out 0Ah,al;mask reg.
mov al,0
out 0Ch,al;Clear the internal DMA flip-flop
mov ax,[poi];cmszmts
add ax,4096
mov bx,16
mul bx;dx:ax= lin cm
out 02h,al; lin cm als 8 bit
mov al,ah
out 02h,al; lin cm kv 8  bit
mov al,dl
out 83h,al;page reg.
mov al,01h
out 0Ah,al;mask reg = enable DMA
;dsp:
mov al,24h;8 bit digitalizing with DMA
call writedsp
mov al,0ffh; size low
call writedsp
mov al,0ffh;size high
call writedsp
mov ax,cs
mov ds,ax
mov al,2;second phase
mov [phase],al

call waiting;IT+KEYB
call save2

;dma+dsp setting to 1.block
;dma:
mov al,01h;[dmach]
add al,04h
out 0Ah,al;mask reg.
mov al,0
out 0Ch,al;Clear the internal DMA flip-flop
mov ax,[poi];cmszmts
mov bx,16
mul bx;dx:ax= lin cm
out 02h,al; lin cm als 8 bit
mov al,ah
out 02h,al; lin cm kv 8  bit
mov al,dl
out 83h,al;page reg.
mov al,01h
out 0Ah,al;mask reg = enable DMA
;dsp:
mov al,24h;8 bit digitalizing with DMA
call writedsp
mov al,0ffh; size low
call writedsp
mov al,0ffh;size high
call writedsp
mov ax,cs
mov ds,ax
mov al,1;first phase
mov [phase],al

jmp record; GOTO main record cicle

vege:;deinit
cli
mov ax,[es:mszak]
mov [0Dh*4],ax
mov ax,[es:mszak+2]
mov [0Dh*4+2],ax
mov ax,cs
mov ds,ax
;restore interrupt mask
mov al,[mask]
out 21h,al
sti

mov al,01h;disable DMA CH1
add al,04h
out 0Ah,al

mov ax,4900h; free memory
mov bx,[poi]
mov es,bx
int 21h
end

puffer1: